/*
 * Tapioca library
 * Copyright (C) 2005 INdT 
 * @author Abner Jose de Faria Silva <abner.silva@indt.org.br>
 * @author Andre Moreira Magalhaes <andre.magalhaes@indt.org.br>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __TAPIOCA_TEXT_SESSION_H__
#define __TAPIOCA_TEXT_SESSION_H__

#include <glib.h>
#include <glib-object.h>

#include <tapioca/core/tapioca_enums.h>
#include <tapioca/client/tapioca_session.h>

G_BEGIN_DECLS

#define TAPIOCA_TYPE_TEXT_SESSION \
    (tapioca_text_session_get_type ())
#define TAPIOCA_TEXT_SESSION(obj) \
    (G_TYPE_CHECK_INSTANCE_CAST ((obj), TAPIOCA_TYPE_TEXT_SESSION, TapiocaTextSession))
#define TAPIOCA_TEXT_SESSION_CLASS(klass) \
    (G_TYPE_CHECK_CLASS_CAST ((klass), TAPIOCA_TYPE_TEXT_SESSION, TapiocaTextSessionClass))
#define IS_TAPIOCA_TEXT_SESSION(obj) \
    (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TAPIOCA_TYPE_TEXT_SESSION))
#define IS_TAPIOCA_TEXT_SESSION_CLASS(klass) \
    (G_TYPE_CHECK_CLASS_TYPE ((klass), TAPIOCA_TYPE_TEXT_SESSION))
#define TAPIOCA_TEXT_SESSION_GET_CLASS(obj) \
    (G_TYPE_INSTANCE_GET_CLASS ((obj), TAPIOCA_TYPE_TEXT_SESSION, TapiocaTextSessionClass))
#define TAPIOCA_TEXT_SESSION_GET_PRIVATE(obj) \
    (G_TYPE_INSTANCE_GET_PRIVATE ((obj), TAPIOCA_TYPE_TEXT_SESSION, TapiocaTextSessionPrivate))

typedef struct _TapiocaTextSession           TapiocaTextSession;
typedef struct _TapiocaTextSessionClass      TapiocaTextSessionClass;
typedef struct _TapiocaTextSessionPrivate    TapiocaTextSessionPrivate;

struct _TapiocaTextSessionClass {
    TapiocaSessionClass parent_class;
};

struct _TapiocaTextSession {
    TapiocaSession parent;
    TapiocaTextSessionPrivate *priv;
};

GType    tapioca_text_session_get_type              (void);

gboolean tapioca_text_session_send                  (TapiocaTextSession *session,
                                                     TapiocaTextSessionMessageType type,
                                                     const gchar *subject,
                                                     const gchar *body);
void     tapioca_text_session_clear_message_queue   (TapiocaTextSession *session);
void     tapioca_text_session_enable_message_queue  (TapiocaTextSession *session);
void     tapioca_text_session_disable_message_queue (TapiocaTextSession *session);
                                                          
G_END_DECLS

#endif
