/*
 * Tapioca library
 * Copyright (C) 2005 INdT 
 * @author Andre Moreira Magalhaes <andre.magalhaes@indt.org.br>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __TAPIOCA_CONNECTION_MANAGER_H__
#define __TAPIOCA_CONNECTION_MANAGER_H__

#include <glib.h>
#include <glib-object.h>
#include <dbus/dbus-glib-bindings.h>

#include <tapioca/core/tapioca_connection.h>

G_BEGIN_DECLS

#define TAPIOCA_TYPE_CONNECTION_MANAGER              (tapioca_connection_manager_get_type ())
#define TAPIOCA_CONNECTION_MANAGER(object)           (G_TYPE_CHECK_INSTANCE_CAST ((object), TAPIOCA_TYPE_CONNECTION_MANAGER, TapiocaConnectionManager))
#define TAPIOCA_CONNECTION_MANAGER_CLASS(klass)      (G_TYPE_CHECK_CLASS_CAST ((klass), TAPIOCA_TYPE_CONNECTION_MANAGER, TapiocaConnectionManagerClass))
#define IS_TAPIOCA_CONNECTION_MANAGER(object)        (G_TYPE_CHECK_INSTANCE_TYPE ((object), TAPIOCA_TYPE_CONNECTION_MANAGER))
#define IS_TAPIOCA_CONNECTION_MANAGER_CLASS(klass)   (G_TYPE_CHECK_CLASS_TYPE ((klass), TAPIOCA_TYPE_CONNECTION_MANAGER))
#define TAPIOCA_CONNECTION_MANAGER_GET_CLASS(obj)    (G_TYPE_INSTANCE_GET_CLASS ((obj), TAPIOCA_TYPE_CONNECTION_MANAGER, TapiocaConnectionManagerClass))
#define TAPIOCA_CONNECTION_MANAGER_GET_PRIVATE(obj)  (G_TYPE_INSTANCE_GET_PRIVATE ((obj), TAPIOCA_TYPE_CONNECTION_MANAGER, TapiocaConnectionManagerPrivate))

typedef struct _TapiocaConnectionManager        TapiocaConnectionManager;
typedef struct _TapiocaConnectionManagerClass   TapiocaConnectionManagerClass;
typedef struct _TapiocaConnectionManagerPrivate TapiocaConnectionManagerPrivate;

struct _TapiocaConnectionManagerClass
{
  GObjectClass parent;

  TapiocaConnection * (* create_connection) (TapiocaConnectionManager *tcm,
                                             GError **error);
};

struct _TapiocaConnectionManager
{
  GObject parent;

  TapiocaConnectionManagerPrivate *priv;
};

GType    tapioca_connection_manager_get_type          (void);

gboolean tapioca_connection_manager_create_connection (TapiocaConnectionManager *tcm,
                                                       gchar **object_path,
                                                       GError **error);

G_END_DECLS

#endif
